# TODO: 20150531 - there's a temporary new home  http://geeqie.org
#   with a git server to replace access to gitorious that will be lost

%{!?_pkgdocdir: %global _pkgdocdir %{_docdir}/%{name}-%{version}}

%define upstreamversion 1.2
%global _hardened_build 1

Summary: Image browser and viewer
Name: geeqie
Version: 1.2
Release: 0.6.20150812git2b87884%{?dist}
License: GPLv2+
Group: User Interface/X
#Source: http://downloads.sf.net/sourceforge/geeqie/%{name}-%{upstreamversion}.tar.gz

# git clone git://www.geeqie.org/geeqie.git
# cd geeqie
# git checkout v1.2.1
# rm -rf .git
Source: geeqie-v1.2.1.tar.xz
BuildRequires: autoconf automake libtool

# https://raw.githubusercontent.com/hughsie/fedora-appstream/master/appdata-extra/desktop/geeqie.appdata.xml
Source1: geeqie.appdata.xml
# for /usr/bin/appstream-util
BuildRequires: libappstream-glib

# originally http://geeqie.sf.net
# but geeqie.org is the temporary new home and git server
URL: http://geeqie.org

# add -Wl,--as-needed without disturbing %%configure macro
Patch0: geeqie-1.1-LDFLAGS.patch

# in upstream bug tracker
# status: still open
# doesn't apply anymore due to changes in fullscreen.c
Patch2: geeqie-1.0-fix-fullscreen.patch

# reported upstream
# https://sourceforge.net/tracker/?func=detail&atid=1054680&aid=3602709&group_id=222125
# not fixed in 1.2
Patch5: geeqie-1.1-filedata-change-notification.patch

# reported upstream
# https://sourceforge.net/tracker/?func=detail&aid=3605406&group_id=222125&atid=1054682
# and gitorious merge request
Patch7: geeqie-1.1-large-files.patch

BuildRequires: gtk2-devel
BuildRequires: lcms2-devel
BuildRequires: exiv2-devel
BuildRequires: lirc-devel
BuildRequires: libjpeg-devel
#BuildRequires: libtiff-devel
BuildRequires: gettext intltool desktop-file-utils
BuildRequires: gnome-doc-utils

# for the included plug-in scripts
BuildRequires: exiv2 fbida ImageMagick zenity
Requires: exiv2 fbida ImageMagick zenity
# at run-time, it is only displayed in menus, if ufraw executable is available
%if 0%{?fedora}
BuildRequires: ufraw
%endif


# Experimental, still disabled by default.
#BuildRequires: libchamplain-gtk-devel >= 0.4


%description
Geeqie has been forked from the GQview project with the goal of picking up
development and integrating patches. It is an image viewer for browsing
through graphics files. Its many features include single click file
viewing, support for external editors, previewing images using thumbnails,
and zoom.


%prep
#setup -q -n %{name}-%{upstreamversion}
%setup -q -n %{name}
autoreconf -f -i ; intltoolize
# guard against missing executables at (re)build-time,
# these are needed by the plug-in scripts
for f in exiftran exiv2 mogrify zenity ; do
    type $f || exit -1
done
%if 0%{?fedora}
for f in ufraw-batch ; do
    type $f || exit -1
done
%endif
%patch0 -p1 -b .LDFLAGS
#patch2 -p1 -b .fix-fullscreen
%patch5 -p1 -b .filedata-notification
%patch7 -p1 -b .large-files

%build
%configure --enable-lirc --disable-tiff \
    --with-readmedir=%{_pkgdocdir}
make %{?_smp_mflags}


%install
mkdir -p ${RPM_BUILD_ROOT}%{_pkgdocdir}/html
make DESTDIR=${RPM_BUILD_ROOT} INSTALL="install -p" install

# guard against missing HTML tree
[ ! -f ${RPM_BUILD_ROOT}%{_pkgdocdir}/html/index.html ] && exit -1

# We want these _docdir files in GQ_HELPDIR.
install -p -m 0644 AUTHORS BUGS CODING COPYING ChangeLog NEWS README* TODO \
    ${RPM_BUILD_ROOT}%{_pkgdocdir}

desktop-file-install \
    --delete-original \
    --dir ${RPM_BUILD_ROOT}%{_datadir}/applications \
    ${RPM_BUILD_ROOT}%{_datadir}/applications/%{name}.desktop

%find_lang %name

install -D -m0644 %{SOURCE1} ${RPM_BUILD_ROOT}%{_datadir}/appdata/%{name}.appdata.xml
appstream-util validate-relax --nonet ${RPM_BUILD_ROOT}%{_datadir}/appdata/%{name}.appdata.xml


%post
update-desktop-database &> /dev/null || :


%postun
update-desktop-database &> /dev/null || :


%files -f %{name}.lang
%doc %{_pkgdocdir}/
%license COPYING
%{_bindir}/%{name}*
%{_prefix}/lib/%{name}/
%{_mandir}/man1/%{name}.1*
%{_datadir}/%{name}/
%{_datadir}/pixmaps/%{name}.png
%{_datadir}/applications/*%{name}.desktop
%{_datadir}/appdata/%{name}.appdata.xml


%changelog
* Wed Aug 26 2015 Michael Schwendt <mschwendt@fedoraproject.org> - 1.2-0.6.20150812git2b87884
- Update To Tag V1.2.1 for a few merged commit requests,
  shall also fix:
  (rhbz #1223349 patch by Sami Farin - crash for Preload next image)
  (rhbz #1231644 orientation hack makes loading image 100x slower)

- update URL to new geeqie.org

* Wed Jun 24 2015 Rex Dieter <rdieter@fedoraproject.org> - 1.2-0.5.20141130gita1afabd
- rebuild (exiv2)

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-0.4.20141130gita1afabd
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat May 02 2015 Kalev Lember <kalevlember@gmail.com> - 1.2-0.3.20141130gita1afabd
- Rebuilt for GCC 5 C++11 ABI change

* Wed Mar 25 2015 Michael Schwendt <mschwendt@fedoraproject.org> - 1.2-0.2.20141130gita1afabd
- Merge Fedora appdata file as requested on devel@ list.
- Use %%license macro.

* Sun Nov 30 2014 Michael Schwendt <mschwendt@fedoraproject.org> - 1.2-0.1.20141130gita1afabd
- TODO: Lua support wants lua5.1.pc >= 5.1, which isn't available
  (only lua.pc 5.2.x exists).
- TODO: what's up with the aging fullscreen patch?
- Add new BUGS file to documentation.
- Drop the LCMS1 bcond.
- Some patches not needed anymore.
- Drop old conditional for desktop file vendor. 
- Update to 1.2 from gitorious including the merged LCMS2 patch (post-1.2).
  No official tarball release yet.

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1-22
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Tue Jun 17 2014 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-21
- Retrieve a printable CMS image profile and screen profile description
  to avoid crashing g_markup (#1110073).

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1-20
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed May 28 2014 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-19
- Don't print CMS screen profileID garbage that crashes g_markup
  (this should also fix #1051660).

* Tue May 27 2014 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-18
- Merge fix for avoiding crash due to inexistent files in collections.
  This also replaces the history path_list patch.

* Sun Jan 26 2014 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-17
- Merge image-overlay.c fix for handling of filenames with % in them.

* Mon Dec  9 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-16
- Add LCMS2 patch from Geeqie-devel list, fix HAVE_LCMS and build with
  lcms2-devel instead of lcms-devel.

* Tue Dec 03 2013 Rex Dieter <rdieter@fedoraproject.org> - 1.1-15
- rebuild (exiv2)

* Sat Nov 16 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-14
- Conditionalize ufraw BR/R for Fedora, since it's not available with
  RHEL and EPEL and is optional at run-time.
- Drop %%defattr usage.

* Tue Aug  6 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-13
- For F-20 unversioned docdirs feature we need to build with
  configure --with-readmedir=... to override the internal GQ_HELPDIR.

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jun  7 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-11
- Define _hardened_build 1 to please rpm-chksec.

* Wed Feb 20 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-10
- Include config.h earlier in some files, so the large file support
  definition is available early enough for e.g. sys/stat.h
- Drop the aging Obsoletes tag for gqview.

* Fri Feb  8 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-9
- Avoid abort when opening non-existing paths from history.

* Fri Feb  1 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-8
- Drop new idle callback from file_data_send_notification() as it
  causes breakage (in the duplicate finder, for example).

* Sun Jan 27 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-7
- Check exec value for NULL in src/editors.c
- Fedora >= 19: Drop ancient "fedora" vendor prefix from desktop file.

* Fri Jan 18 2013 Adam Tkac <atkac redhat com> - 1.1-6
- rebuild due to "jpeg8-ABI" feature drop

* Mon Dec 24 2012 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-5
- Fix crash upon escaping from generic dialogs.

* Thu Dec 13 2012 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-4
- Build with --disable-tiff, as the custom libtiff loader crashes
  for some images as mentioned on geeqie-devel list.

* Thu Nov 22 2012 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-3
- Merge a patch to fix fullscreen mode.

* Sun Aug 26 2012 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-2
- Merge bar_keywords.c master commit to fix regression.

* Tue Aug 14 2012 Michael Schwendt <mschwendt@fedoraproject.org> - 1.1-1
- Fix license tag to GPLv2+ as GPL3 (only in file COPYING) had been
  added only temporarily for 1.0-alpha1.
- BR libjpeg-devel libtiff-devel
- Upgrade to 1.1 (also to reduce patch count).

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu May  3 2012 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-17
- Complete previous rebuild that failed unexpectedly because html docdir in
  buildroot had not been created (Rawhide only). Now create it explicitly
  at beginning of %%install.

* Wed May 02 2012 Rex Dieter <rdieter@fedoraproject.org> - 1.0-16
- rebuild (exiv2)

* Fri Jan  6 2012 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-15
- rebuild for GCC 4.7 as requested

* Sat Nov  5 2011 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-14
- Link with --as-needed.

* Sun Oct 16 2011 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-13
- Cherry-pick a few commits (from Vladimir Nadvornik, Klaus Ethgen
  and Vladislav Naumov). With the modified filelist_sort_compare_filedata
  method, Geeqie passes another stress test I've created in order
  to track down rare file_data_unref crashes.

* Fri Oct 14 2011 Rex Dieter <rdieter@fedoraproject.org> - 1.0-12
- rebuild (exiv2)

* Tue Aug  9 2011 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-11
- Patch another place where not to exif_free_fd NULL ptr (#728802).

* Fri Apr 15 2011 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-10
- Let's see how we do with a simpler vflist_setup_iter_recursive().

* Sat Mar  5 2011 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-9
- Patch filedata.c check_case_insensitive_ext to accept the first
  tested file name ext and not accept multiple combinations due to
  case-insensitive fs.

* Fri Mar  4 2011 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-8.test1
- Patch filedata.c check_sidecars to avoid adding a file as its own
  sidecar. Case-insensitive sidecar file name generation may not be
  enough if a fs stat is used in conjunction with a case-insensitive fs.

* Tue Feb 22 2011 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-8
- Fix file cache NULL pointer crash in exif-common.c (#679256).
- Patch and build with large file support.

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Jan 02 2011 Rex Dieter <rdieter@fedoraproject.org> - 1.0-6
- rebuild (exiv2)

* Thu Sep  9 2010 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-5
- Make gqview "Obsoletes" tag conditional: for Fedora newer than 13.

* Mon Jul 26 2010 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-4
- Replace old gqview < 2.0.4-13 with geeqie.

* Mon May 31 2010 Rex Dieter <rdieter@fedoraproject.org> - 1.0-3 
- rebuild (exiv2)

* Tue Apr  6 2010 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-2
- require exiv2, ImageMagick, fbida, ufraw, zenity for plug-in scripts
- BR gnome-doc-utils for HTML documentation (and "Help > Contents" menu)

* Fri Feb 19 2010 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-1
- update to 1.0 final release
 
* Mon Jan 04 2010 Rex Dieter <rdieter@fedoraproject.org> - 1.0-0.20.beta2
- rebuild (exiv2)

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-0.19.beta2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Jul  6 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.18.beta2
- update to beta2 tarball
- BR intltool
- print-pagesize.patch enabled in 1.0beta2 (#222639)

* Thu May 14 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.16.beta1
- update to beta1 tarball

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-0.15.alpha3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Feb  7 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.14.alpha3
- fetch src/utilops.c change from svn 1385 for metadata crash-fix

* Wed Jan 28 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.13.alpha3
- ignore .helpdir/.htmldir values in geeqierc to fix "Help"
- add --enable-lirc again to build with LIRC

* Mon Jan 26 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.12.alpha3
- update to alpha3 tarball

* Thu Jan 22 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.11.alpha2.1341svn
- update to svn 1341 for pre-alpha3 testing (image metadata features)
- drop obsolete patches remote-blank and float-layout

* Wed Dec 24 2008 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.11.alpha2.1307svn
- update to svn 1307 for "Safe delete"

* Thu Dec 18 2008 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.11.alpha2.1299svn
- drop desktop file Exec= invocation patch (no longer necessary)

* Thu Dec 18 2008 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.10.alpha2.1299svn
- update to svn 1299 for new exiv2
- disable LIRC support which is broken

* Thu Dec 18 2008 Rex Dieter <rdieter@fedoraproject.org> - 1.0-0.9.alpha2
- respin (exiv2)

* Tue Aug 12 2008 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.8.alpha2
- fix float layout for --blank mode

* Mon Aug 11 2008 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.7.alpha2
- fix options --blank and -r file:

* Thu Jul 31 2008 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.6.alpha2
- update to 1.0alpha2 (now GPLv3)
- build with new LIRC support

* Wed Jun 25 2008 Rex Dieter <rdieter@fedoraproject.org> - 1.0-0.5.alpha1 
- respin for exiv2

* Thu May  8 2008 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.4.alpha1
- scriptlets: run update-desktop-database without path
- drop dependency on desktop-file-utils
- drop ChangeLog file as it's too low-level

* Fri Apr 25 2008 Michael Schwendt <mschwendt@fedoraproject.org> - 1.0-0.3.alpha1
- package GQview fork "geeqie 1.0alpha1" based on Fedora gqview.spec
- BR lcms-devel exiv2-devel
- update -desktop and -editors patch
- update spec file with more dir macros

